//------------------------------------------------------------------------------
//
//  npgl.c
//  ANTZ application based on NPE
//
//  Created by Shane Saxon on 2/19/10.
//  Copyright Saxon Digital 2010. All rights reserved.
//
//------------------------------------------------------------------------------


#include "npgl.h"


static float angle = 0.0, ratio;
static float x = 0.0f, y = 1.75f, z=5.0f;
static float lx = 0.0f, ly = 0.0f, lz = -1.0f;


void npGLResizeScene (int width, int height);


//------------------------------------------------------------------------------
void npInitGL(void* dataRef) 
{
	npInitGLDraw (dataRef);

//	glShadeModel (GL_SMOOTH);
//	glClearColor (0.0f, 0.0f, 0.0f, 0.0f);
//	glClearDepth (1.0f);

	glEnable (GL_DEPTH_TEST);

//	glDepthFunc (GL_LEQUAL);
//	glHint (GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
}


//------------------------------------------------------------------------------
void npGLResizeScene (int width, int height)
{
	pData data = npDataGetDataRef();

	NPplotPtr camPlot = data->map.plot[1];
	NPcameraPtr camData = camPlot->data;

	if (height == 0)			// Prevent a divide by zero
		height = 1;

	ratio = 1.0f * width / height;

	// Reset the coordinate system before modifying
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	
	// Set the viewport to be the entire window
    glViewport(0, 0, width, height);

	// Set the clipping volume
	gluPerspective (45.0f, ratio, 1.0f, 1000.0f);
	glMatrixMode (GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt (	camPlot->translate.x, 
				camPlot->translate.y,
				camPlot->translate.z, 
				camPlot->translate.x + camPlot->rotate.x,
				camPlot->translate.y + camPlot->rotate.y,
				camPlot->translate.z + camPlot->rotate.z,
				0.0f, 1.0f, 0.0f );
			//	camPlot->rotate.x,
			//	camPlot->rotate.y,
			//	camPlot->rotate.z );
}


